在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

solidworks中如果焊件的零件不是由“结构构件”生成的话,切割清单项目的属性默认情况下会生成“材料”和“数量”2个属性。

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

今天我会用“宏”来自动的给切割清单中的零件添加“单重”和“总重”,并自动链接到工程图中,这在实际工作中是非常有用的,比如零件好几百的板料的焊件,下料的尺寸、数量和重量统计。如果人工智能来做的话,不仅容易出错,工作也很繁琐。

对于先前说的如何出下料的尺寸图,亲们可以以参考这篇文章《工程图中相对视图在solidworks多实体焊件零件中的应用把把有的下料图链接到同一张图纸上。

今天我就给亲讲一下如何把数量和重重链接到solidworks工程图的“焊接清单明细表”中。

1.运行宏,生成单重和总重

1.1宏代码

  1. Option Explicit
  2. Dim swApp As SldWorks.SldWorks
  3. Dim Part As SldWorks.ModelDoc2
  4. Dim thisFeat As SldWorks.feature
  5. Dim thisSubFeat As SldWorks.feature
  6. Dim cutFolder As Object
  7. Dim BodyCount As Integer
  8. Dim fn As String
  9. Dim pn As String
  10. Dim custPropMgr As SldWorks.CustomPropertyManager
  11. Dim propNames As Variant
  12. Dim vName As Variant
  13. Dim propName As String
  14. Dim Value As String
  15. Dim resolvedValue As String
  16. Dim TotalW As Double
  17. Sub main()
  18. Set swApp = Application.SldWorks
  19. Set Part = swApp.ActiveDoc
  20. Set thisFeat = Part.FirstFeature
  21. Do While Not thisFeat Is Nothing
  22.     If thisFeat.GetTypeName = "SolidBodyFolder" Then
  23.         thisFeat.GetSpecificFeature2.UpdateCutList
  24.     End If
  25.     Set thisSubFeat = thisFeat.GetFirstSubFeature
  26.     Do While Not thisSubFeat Is Nothing
  27.         If thisSubFeat.GetTypeName = "CutListFolder" Then
  28.             Set cutFolder = thisSubFeat.GetSpecificFeature2
  29.         End If
  30.         If Not cutFolder Is Nothing Then
  31.             BodyCount = cutFolder.GetBodyCount
  32.             If BodyCount > 0 Then
  33.                 Set custPropMgr = thisSubFeat.CustomPropertyManager
  34.                 If Not custPropMgr Is Nothing Then
  35.                     custPropMgr.Delete "Total Weight"
  36.                     custPropMgr.Delete "Weight"
  37.                     fn = thisSubFeat.Name
  38.                     pn = Part.GetTitle
  39.                     custPropMgr.Add "Weight", "文字", Chr(34) & "SW-Mass@@@" & fn & "@" & pn & Chr(34)
  40.                     propNames = custPropMgr.GetNames
  41.                     If Not IsEmpty(propNames) Then
  42.                         For Each vName In propNames
  43.                             propName = vName
  44.                             custPropMgr.Get2 propName, Value, resolvedValue
  45.                             If propName = "Weight" Then TotalW = resolvedValue
  46.                         Next vName
  47.                     End If
  48.                     custPropMgr.Add "Total Weight", "文字", Format(BodyCount * TotalW, "0.00")
  49.                 End If
  50.             End If
  51.         End If
  52.         Set thisSubFeatthisSubFeat = thisSubFeat.GetNextSubFeature
  53.     Loop
  54.     Set thisFeatthisFeat = thisFeat.GetNextFeature
  55. Loop
  56. End Sub

1.2新建宏

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

1.3运行宏后添加单重和总重属性

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

2.在工程图的焊接清单中添加单重和总重

2.1添加单重

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

2.2添加总重

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

素材文件

在solidowork焊件的工程图的-焊接清单-自动链接出-单重和总重

发表评论

:?: :razz: :sad: :evil: :!: :smile: :oops: :grin: :eek: :shock: :???: :cool: :lol: :mad: :twisted: :roll: :wink: :idea: :arrow: :neutral: :cry: :mrgreen: